Index: main/pbx.c
===================================================================
--- main/pbx.c	(revision 81366)
+++ main/pbx.c	(working copy)
@@ -4964,6 +4964,7 @@
 	int res = -1, cdr_res = -1;
 	struct outgoing_helper oh;
 	pthread_attr_t attr;
+	char failreason[4];
 
 	if (sync) {
 		LOAD_OH(oh);
@@ -5038,6 +5039,10 @@
 						ast_copy_string(chan->context, context, sizeof(chan->context));
 					set_ext_pri(chan, "failed", 1);
 					ast_set_variables(chan, vars);
+					snprintf(failreason, sizeof(failreason), "%d",*reason);
+
+					pbx_builtin_setvar_helper(chan, "REASON", failreason);
+
 					if (account)
 						ast_cdr_setaccount(chan, account);
 					ast_pbx_run(chan);
